<fieldset class="adminform">
<legend><?php echo _T( 'COMPONENT_LINKS' ); ?></legend>
<table class="admintable" cellspacing="1">
<tbody>

<?php
  $rowNo = 0;
  foreach ($this->menus as $menu):
    $component = strstr( $menu->link, 'com_' );
    $field = '[' . $component . '][' . $menu->id . ']';
    $alias = $this->site->getComponentAlias( $component, $menu->id );
    $blocked = $this->site->getComponentBlock( $component, $menu->id );

    $checked = !is_null( $alias );
    if (!$checked) {
      $alias = $menu->treename;
      $alias = (!isset( $this->mapper ) ? sefEncode( $alias ) :
        $this->mapper->encode( $alias ));
    }
    if ($blocked) {
    	$checked = 0;
    }
?>
<tr>
  <td class="key" valign="top" align="left" nowrap="1"><b><?php echo $menu->treename ?></b>&nbsp;&nbsp;</td>
  <td valign="top" align="left" nowrap="1">
    <input type="checkbox" name="<?php echo '_block' . $field ?>" value="1"
      <?php if ($blocked): ?>checked="1"<?php endif; ?>
      class="text_area" />&nbsp;<?php echo _T( 'BLOCK_COMP' ) ?>&nbsp;
  </td>
  <td valign="top" align="left" nowrap="1">
    <input type="checkbox" name="<?php echo '_component' . $field ?>" value="1"
      <?php if ($checked): ?>checked="1"<?php endif; ?>
      class="text_area" />&nbsp;<?php echo _T( 'USE_ALIAS' ) ?>:&nbsp;
  </td>
  <td valign="top" align="left" width="50%">
    <?php $x = xclHTML::textbox( $alias, null, '_alias' . $field, 20 ); echo $x->html; ?>
  </td>
  <td valign="top" align="left"><?php echo $menu->menutype ?>&nbsp;</td>
  <td valign="top" align="left"><?php echo $component ?>&nbsp;</td>
  <td valign="top" align="center"><?php echo $menu->id ?>&nbsp;</td>
</tr>
<?php
  endforeach;
?>
</tbody></table></fieldset></td></tr></table></div>