<?php
/*
SEO_Assistant for OSC 2.2 MS2 v2.0  08.03.2004
Originally Created by: Jack York
Released under the GNU General Public License
osCommerce, Open Source E-Commerce Solutions
Copyright (c) 2004 osCommerce
*/

//http://www.google.com/search?hl=en&lr=&q=link%3Awww.open-sef.org
function getLinkPopularity($link_url) {
	$host = "www.google.com";
	$path = "/search?hl=en&lr=&q=link:" . $link_url;
	$fp = fsockopen($host, "80", $errno, $errstr);
	if (! $fp) {
		echo "$errstr ($errno)<br />\n";
		return false;
	} else {
		fputs($fp, "GET ".$path." HTTP/1.0\r\nHost: ".$host."\r\n\r\n");
		while(!feof($fp)) {
			$line = fgets($fp, 4096);
			if (preg_match("/of about/", $line)) {
				$total_sites = $line;
				$total_sites = preg_replace("/^.*of about <b>/", "", $total_sites);
				$total_sites = preg_replace("/<.*$/", "", $total_sites);
				$total_sites = preg_replace("/\,/", "", $total_sites);
				$total_sites = trim($total_sites);
				return $total_sites;
			}
		}
	}
}

//http://search.yahoo.com/search?p=link%3Ahttp%3A%2F%2Fwww.cre8asiteforums.com%2Findex.php&ei=UTF-8&fr=FP-tab-web-t&n=20&fl=0&x=wrt
function get_yahoo_links($domain) {
	$lines = array();
	$host = "search.yahoo.com";
	$path = "search?p=link%3Ahttp%3A%2F%2F" . $domain;
	$fp = fsockopen($host, "80");
	if ($fp) {
		fputs($fp, "GET ".$path." HTTP/1.0\r\nHost: ".$host."\r\n\r\n");
		while(!feof($fp)) {
			$line = fgets($fp, 4096);
			if (preg_match("/^1 \- /", $line)) {
				$total_sites = $line;
				$total_sites = preg_replace("/^.*of /", "", $total_sites);
				$total_sites = preg_replace("/ .*$/", "", $total_sites);
				$total_sites = preg_replace("/\,/", "", $total_sites);
				$total_sites = trim($total_sites);
				return($total_sites);
			}
		}
	} else {
		echo "Can't connect to host... ";
	}
}

function ListFiles()
{
	$files = array();
	$dir = opendir('.');
	while(($file = readdir($dir)) !== false)
	{
		if($file !== '.' && $file !== '..' && !is_dir($file))
		{
			$files[] = $file;
		}
	}
	closedir($dir);
	sort($files);
	return $files;
}

function checkLinks($url, $idx) {
	global $badLinks, $totalLinks;

	$file = @fopen($url,'r');
	if (! $file) {
		$badLinks[$idx] = $url;
		// echo 'add bad link MAIN '. $url . ' at pos '. $idx . ' result = ' .$badLinks[$idx].'<br>';
		$idx++;
		$totalLinks++;
	} else {
		$totalLinks++;
		while (!feof($file)) {
			$page_line = trim(fgets($file, 4096));
			if (eregi('http:', $page_line)) {
				$link = stristr($page_line, 'http:');
				if ($link !== FALSE) {
					$pos = strpos($link, '"');
					if ($pos !== FALSE)
						$link = substr($link, 0, $pos);
					$actual_link = @fopen($link,'r');
					$totalLinks++;
					if (! $actual_link) {
						$badLinks[$idx] = $link;
						// echo 'add bad link SUB '. $link . ' at pos '. $idx . ' result = ' .$badLinks[$idx].'<br>';
						$idx++;
					} else {
						fclose($actual_link);
					}
				}
			}
		}
		fclose($file);
	}
}
/*
SEO_Assistant for OSC 2.2 MS2 v2.0  08.03.2004
Originally Created by: Jack York
Released under the GNU General Public License
osCommerce, Open Source E-Commerce Solutions
Copyright (c) 2004 osCommerce
*/
function linkcheck($path, $engine) {
	global $results;
	global $total;

	if(!file_exists($path)) {
		$data = strtolower(strip_tags(@implode("", @file($path))));
		if (FALSE === strpos($engine, 'msn'))
		$data = substr($data, strpos($data, "of about")+9, strlen($data));
		else
		$data = substr($data, strpos($data, "of")+3, strlen($data));
		$data = substr($data, 0, strpos($data, " "));

		if(eregi("[[:alpha:]]", $data)) {
			$results[$engine] = array('0', $path);
		} else {
			$results[$engine] = array($data, $path);
			$total+=str_replace(',', '', $data);
		}
	} else {
		$results[$engine] = array('n/a', $path);
	}
}

function get_link_popularity($link_url) {
	global $results;
	global $total;


	if($link_url) {


		// the results from Google and MSN can be extracted the same way so a function is used to simplify the code
		linkcheck("http://www.google.com/search?hl=en&lr=&ie=UTF-8&q=site%3A".$link_url, 'google');
		linkcheck("http://search.msn.com/results.aspx?FORM=MSNH&q=site%3A".$link_url, 'msn');

		// check Yahoo!
		$path ="http://search.yahoo.com/search?p=linkdomain%3A".$link_url."&ei=UTF-8&fr=fp-tab-web-t&cop=mss&tab=";
		if(!file_exists($path)) {
			$data = strtolower(@implode("", @file($path)));
			$data = substr($data, strpos($data, "of about")+9, strlen($data));
			$data = strip_tags(substr($data, 0, strpos($data, " ")));
			if(eregi("[[:alpha:]]", $data)) {
				$results['yahoo'] = array('0', $path);
			} else {
				$results['yahoo'] = array($data, $path);
				$total+=str_replace(',', '', $data);
			}
		} else {
			$results['yahoo'] = array('n/a', $path);
		}


		// check AlltheWeb
		$path ="http://www.alltheweb.com/search?cat=web&cs=utf8&q=site%3A".$link_url."&rys=0&_sb_lang=pref";
		if(!file_exists($path)) {
			$data = strtolower(strip_tags(@implode("", @file($path))));
			$data = substr($data, strpos($data, "1 -")+5, strlen($data));
			$data = substr($data, 0, strpos($data, "results"));
			$data = trim(substr($data, strpos($data, "of")+3, strlen($data)));
			if(eregi("[[:alpha:]]", $data)) {
				$results['alltheweb'] = array('0', $path);
			} else {
				$results['alltheweb'] = array($data, $path);
				$total+=str_replace(',', '', $data);
			}
		} else {
			$results['alltheweb'] = array('n/a', $path);
		}

		// check HotBot
		$path = "http://www.hotbot.com/default.asp?query=".$link_url."&ps=&loc=searchbox&tab=web&provKey=Ask+Jeeves&prov=Ask+Jeeves";
		//$path ="http://www.hotbot.com/default.asp?query=linkdomain%3A".$link_url."&ps=&loc=searchbox&tab=web&provKey=Inktomi";
		if(!file_exists($path)) {
			$data = strtolower(strip_tags(@implode("", @file($path))));
			$data = substr($data, strpos($data, "results 1 - ")+11, strlen($data));
			$data = substr($data, 0, strpos($data, ")"));
			$data = trim(substr($data, strpos($data, "of")+3, strlen($data)));
			if(eregi("[[:alpha:]]", $data)) {
				$results['hotbot'] = array('0', $path);
			} else {
				$results['hotbot'] = array($data, $path);
				$total+=str_replace(',', '', $data);
			}
		} else {
			$results['hotbot'] = array('n/a', $path);
		}
		//http://www.altavista.com/web/results?q=linkdomain%3Awww.24-7mobileaccessories.co.uk/&kgs=1&kls=0&stq=10
		//http://www.altavista.com/web/results?itag=wrx&pg=aq&aqmode=s&aqa=joe&aqp=&aqo=&aqn=&aqb=&kgs=0&kls=0&dt=tmperiod&d2=0&dfr%5Bd%5D=1&dfr%5Bm%5D=1&dfr%5By%5D=1980&dto%5Bd%5D=6&dto%5Bm%5D=9&dto%5By%5D=2004&filetype=&rc=dmn&swd=www.24-7mobileaccessories.co.uk&lh=&nbq=10
		//http://www.altavista.com/web/results?itag=wrx&pg=aq&aqmode=s&aqa=joe&aqp=&aqo=&aqn=&aqb=&kgs=1&kls=0&dt=tmperiod&d2=0&dfr%5Bd%5D=1&dfr%5Bm%5D=1&dfr%5By%5D=1980&dto%5Bd%5D=6&dto%5Bm%5D=9&dto%5By%5D=2004&filetype=&rc=dmn&swd=www.24-7mobileaccessories.co.uk&lh=&nbq=10
		//http://www.altavista.com/web/results?q=linkdomain%3Awww.mycandysupplier.com&kgs=1&kls=0&stq=10
		// check AltaVista
		$path ="http://www.altavista.com/web/results?q=site%3A".$link_url."&kgs=0&kls=0&stq=10";

		if(!file_exists($path)) {
			$data = strtolower(strip_tags(@implode("", @file($path))));
			$data = substr($data, strpos($data, "altavista found")+15, strlen($data));
			$data = trim(substr($data, 0, strpos($data, "results"))); //echo "$data<br>"; // TEST
			if(eregi("[[:alpha:]]", $data)) {
				$results['altavista'] = array('0', $path);
			} else {
				$results['altavista'] = array($data, $path);
				$total+=str_replace(',', '', $data);
			}
		} else {
			$results['altavista'] = array('n/a', $path);
		}

		// check for listing in DMOZ
		$path ="http://search.dmoz.org/cgi-bin/search?search=".str_replace("www.", "", $link_url);
		if(!file_exists($path)) {
			$data = strip_tags(@implode("", @file($path)));
			if(strpos($data, "No Open Directory Project results found")) {
				$results['dmoz'] = array('No', $path);
			} else {
				$results['dmoz'] = array('Yes', $path);
			}
		} else {
			$results['dmoz'] = array('n/a', $path);
		}

		// check for listing in Zeal
		$path ="http://www.zeal.com/search/results.jhtml?keyword=".$link_url."&scope=directory";
		if(!file_exists($path)) {
			$data = @implode("", @file($path)); //echo $data; // TEST
			if(strpos($data, "found no results")) {
				$results['zeal'] = array('No', $path);
			} else {
				$results['zeal'] = array('Yes', $path);
			}
		} else {
			$results['zeal'] = array('n/a', $path);
		}

		// get Alexa Traffic Rank
		$path ="http://www.alexa.com/data/details/main?q=&url=http://".$link_url;
		//old
		if(!file_exists($path)) {
			$data = strtolower(strip_tags(@implode("", @file($path))));
			$data = substr($data, strpos($data, "traffic rank for ")+17, strlen($data));
			$data = str_replace(str_replace('www.', '', $link_url), '', $data);
			$data = str_replace(':&nbsp;', '', $data);
			$data = trim(substr($data, 0, strpos(trim($data), ' ')-1)); //echo "$data<br>"; // TEST
			if(eregi("[[:alpha:]]", $data)) {
				$results['alexa'] = array('0', $path);
			} else {
				$results['alexa'] = array($data, $path);
			}
		} else {
			$results['alexa'] = array('n/a', $path);
		}
		return $results;
	}
	return false;
}

function seo_google_position ($firstpass,$searchquery,$searchurl,$searchtotal,$showlinks) {
	if(!$firstpass && !empty($searchquery) && !empty($searchurl)) {

		//$search
		$query = str_replace(" ","+",$searchquery);
		$query = str_replace("%26","&",$query);
		// The number of hits per page.
		$hits_per_page = 10;
		// Obviously, the total pages / queries we will be doing is
		// $searchtotal / $hits_per_page
		// This will be our rank
		$position      = 0;
		// This is the rank minus the duplicates
		$real_position = 0;
		$found_google   = NULL;
		$lastURL = NULL;
		for($i=0;$i<$searchtotal && empty($found_google);$i+=$hits_per_page) {
			// Open the search page.
			// We are filling in certain variables -
			// $query,$hits_per_page and $start.
			//http://www.google.com/search?q=opensef&hl=en&lr=&start=10&sa=N
			//http://www.google.com/search?hl=en&q=opensef&btnG=Google+Search
			//http://www.google.com/search?q=opensef&hl=en&lr=&start=0&sa=N
			$filename = "http://www.google.com/search?as_q=$query".
			"&num={$hits_per_page}&hl=en&ie=UTF-8&btnG=Google+Search".
			"&as_epq=&as_oq=&as_eq=&lr=&as_ft=i&as_filetype=".
			"&as_qdr=all&as_nlo=&as_nhi=&as_occt=any&as_dt=i".
			"&as_sitesearch=&safe=images&start=$i";


			//$filename = "http://www.google.com/search?&q=$query".
			//"&hl=en&lr=&start=0&sa=N";
			//"&lr=&start=$i&sa=N";
			$file = fopen($filename, "r");
			if (!$file) {
				echo "<p>Unable to open remote file $filename.\n";
			} else 	{
				// Now load the file into a variable line at a time
				while (!feof($file)) {
					$var = fgets($file, 1024);
					// Try and find the font tag google uses to show the site URL
					if (eregi("<a class=l href=([^>]*)>",$var,$out)) {
						// If we find it take out any <B> </B> tags - google does
						// highlight search terms within URLS
						$out[1] = strtolower($out[1]);
						// Get the domain name by looking for the first /
						if ( eregi( "(http[s]?://([^/]*))/", $out[1], $urlstring ) )
						$url = $urlstring[1];
						$position++;
						// If you want to see the hits, set $showlinks_google to something
						if($showlinks)
						$result_google[] = $url;
						// If the last result process is the same as this one, it
						// is a nest or internal domain result, so don't count it
						// on $real_position
						if(strcmp($lastURL,$url)<>0)
						$real_position++;
						$lastURL = $url;
						$url=str_replace("http://", "", $url);
						if (!ereg("www.",$searchurl) && ereg("www.",$url)){
							$searchurl="www.".$searchurl;
						}
						if (!ereg("www.",$url) && ereg("www.",$searchurl)){
							$url="www.".$url;
						}
						// Else if the sites match we have found it!!!
						if(strcmp($searchurl,$url)==0) {
							$found_google = $position;
							// We quit out, we don't need to go any further.
							break;
						}
					}
				}
			}
			fclose($file);
		}
		$siteName = 'Google';
		if($found_google) {
			$result_google[] = "The site $searchurl is at position $found_google ".
			"( $real_position ) for the term <b>$searchquery</b>" . " on " . "$siteName";
			return $result_google;
		} else 	{
			$result_google[] = "The site $searchurl is not in the top $searchtotal ".
			"for the term <b>$searchquery</b>" . " on " . "$siteName";
			return $result_google;
		}
	}
}

function seo_yahoo_position ($firstpass,$searchquery,$searchurl,$searchtotal,$showlinks) {
	if(!$firstpass && !empty($searchquery) && !empty($searchurl)) {
		$query = str_replace(" ","+",$searchquery);
		$query = str_replace("%26","&",$query);
		// The number of hits per page.
		$hits_per_page = 10;
		// Obviously, the total pages / queries we will be doing is
		// $searchtotal / $hits_per_page
		// This will be our rank
		$position      = 0;
		// This is the rank minus the duplicates
		$real_position = 0;
		$found_yahoo   = NULL;
		$lastURL = NULL;
		for($i=0;$i<$searchtotal && empty($found_yahoo);$i+=$hits_per_page) {
			// Open the search page.
			// We are filling in certain variables -
			// $query,$hits_per_page and $start.
			$page_var=$i+1;
			$filename = "http://search.yahoo.com/search?_adv_prop=web&x=op&ei=UTF-8".
			"&prev_vm=p&va=$query&va_vt=any&vp=&vp_vt=any&vo=&vo_vt=any".
			"&ve=&ve_vt=any&vd=all&vst=0&vs=&vf=all&vm=p".
			"&vc=&fl=0&n={$hits_per_page}&b=$page_var";
			$file = fopen($filename, "r");
			if (!$file) {
				echo "<p>Unable to open remote file $filename.\n";
			} else 	{
				// Now load the file into a variable line at a time
				while (!feof($file)) {
					$var = fgets($file, 1024);
					// Try and find the font tag yahoo uses to show the site URL
					if (eregi("<a class=yschttl  href=([^>]*)>",$var,$out)) {
						// If we find it take out any <B> </B> tags - google does
						// highlight search terms within URLS
						$out[1] = strtolower($out[1]);
						// Get the domain name by looking for the first /
						if ( eregi( "(http[s]?://([^/]*))/", urldecode($out[1]), $urlstring ) )
						$url = $urlstring[1];
						$position++;
						// If you want to see the hits, set $showlinks_google to something
						if($showlinks)
						$result_yahoo[] = $url;
						// If the last result process is the same as this one, it
						// is a nest or internal domain result, so don't count it
						// on $real_position
						if(strcmp($lastURL,$url)<>0)
						$real_position++;
						$lastURL = $url;
						$url=str_replace("http://", "", $url);
						if (!ereg("www.",$searchurl) && ereg("www.",$url)){
							$searchurl="www.".$searchurl;
						}
						if (!ereg("www.",$url) && ereg("www.",$searchurl)){
							$url="www.".$url;
						}
						// Else if the sites match we have found it!!!
						if(strcmp($searchurl,$url)==0) {
							$found_yahoo = $position;
							// We quit out, we don't need to go any further.
							break;
						}
					}
				}
			}
			fclose($file);
		}
		$siteName = 'Yahoo';
		if($found_yahoo) {
			$result_yahoo[] = "The site $searchurl is at position $found_yahoo ".
			"( $real_position ) for the term <b>$searchquery</b>" . " on " . "$siteName";
			return $result_yahoo;
		} else 	{
			$result_yahoo[] = "The site $searchurl is not in the top $searchtotal ".
			"for the term <b>$searchquery</b>" . " on " . "$siteName";
			return $result_yahoo;
		}
	}
}
function kda($url, &$total, $use_meta_tags, $use_partial_total) {
	$text="";
	$ws = array();
	$words = array();
	$occurances = array();
	$meta_tags = array();
	if(!stristr($url, 'http://')) {
		$url = 'http://'.$url;
	}
	if($html = @file_get_contents($url)) {
		$html = html_entity_decode(file_get_contents($url));
		//preg_match('/(?<=<title>).*?(?=<\\/title>)/is', $html, $matches);
		//$title = array_shift($matches);
		$meta_tags = ($use_meta_tags) ? get_meta_tags($url) : '';
		$html = kda_strip_tag_script($html);
		$no_html = strip_tags($html);
		@$tag_info = $meta_tags['description']." ".$meta_tags['keywords'];
		$text .= $tag_info." ".$no_html;
		$total = count(explode(' ', $text));
		$text = kda_clean(kda_stopWords($text));
		$words = explode(' ', $text);
		$total = count($words);
		for($x=0; $x<$total; $x++) {
			$words[$x] = trim($words[$x]);
			if($words[$x]!='') {
				@$ws[$words[$x]]++;
				if(trim(@$words[$x+1])!='') {
					$phrase2 = $words[$x]." ".trim($words[$x+1]);
					@$ws[$phrase2]++;
					if(trim(@$words[$x+2])!='') {
						$phrase3 = $words[$x]." ".trim($words[$x+1])." ".trim($words[$x+2]);
						@$ws[$phrase3]++;
					}
				}
			}
		}
		foreach($ws as $word=>$count) {
			if( ($count>1) and (strlen($word)>2) ) {
				$phrase_size = count(explode(' ', $word));
				@$occurances[$phrase_size] = @$occurances[$phrase_size] + $count;
			}
		}
		foreach($ws as $word=>$count) {
			if( ($count>1) and (strlen($word)>2) ) {
				$phrase_size = count(explode(' ', $word));
				$ttlWords = ($use_partial_total) ? $occurances[$phrase_size] : $total;
				$density = round(($count/$ttlWords)*100, 2);
				$dens[$phrase_size][$word] = $density;
				$dens[$word] = $count;
			}
		}
		arsort($dens[1]);
		if($dens[2]) {
			arsort($dens[2]);
		}
		if($dens[3]) {
			arsort($dens[3]);
		}
		return $dens ;
	}else {
		return false;
	}
}

function kda_strip_tag_script($html) {
	$pos1 = false;
	$pos2 = false;
	do {
		if ($pos1 !== false && $pos2 !== false) {
			$first = NULL;
			$second = NULL;
			if ($pos1 > 0)
			$first = substr($html, 0, $pos1);
			if ($pos2 < strlen($html) - 1)
			$second = substr($html, $pos2);
			$html = $first . $second;
		}
		preg_match("/<script[^>]*>/i", $html, $matches);
		$str1 =& $matches[0];
		preg_match("/<\/script>/i", $html, $matches);
		$str2 =& $matches[0];
		$pos1 = strpos($html, $str1);
		$pos2 = strpos($html, $str2);
		if ($pos2 !== false)
		$pos2 += strlen($str2);
	} while ($pos1 !== false && $pos2 !== false);

	return $html;
}

function kda_clean($text) {
	global $stopwords_file;
	$text = str_replace('.', '', $text);
	$text = str_replace(',', '', $text);
	$text = str_replace('(', '', $text);
	$text = str_replace(')', '', $text);
	$text = str_replace('_', '', $text);
	$text = str_replace('*', '', $text);
	$text = str_replace('"', '', $text);
	$text = str_replace('-', '', $text);
	$text = str_replace("!", '', $text);
	$text = str_replace("?", '', $text);
	$text = str_replace("\n", '', $text);
	$text = str_replace('/', '', $text);
	$text = str_replace('|', '', $text);
	$text = str_replace('&#8217;', "'", $text);

	return trim(strtolower($text));
}

function kda_stopWords($term) {
	global $mosConfig_absolute_path;
	global $sw_count, $sefConfig;
	$clean_term = "";
	//load list of common words
	$common = file($mosConfig_absolute_path.'/administrator/components/com_sef/includes/seo_words/seo_words_'.$sefConfig->backend_language.'.txt');
	$total = count($common);
	for ($x=0; $x < $total; $x++) {
		$common[$x] = trim(strtolower($common[$x]));
	}
	//make array of search terms
	$_terms = explode(" ", $term);
	foreach ($_terms as $line) {
		if (in_array(strtolower(trim($line)), $common)) {
			$removeKey = array_search($line, $_terms);
			$sw_count++;
			unset($_terms[$removeKey]);
		} else {
			$clean_term .= " ".$line;
		}
	}
	return $clean_term;
}

Class GooglePR {

	//Public vars
	var $googleDomains = Array("toolbarqueries.google.com","www.google.com","toolbarqueries.google.com.tr","www.google.com.tr","toolbarqueries.google.de","www.google.de", "64.233.187.99", "72.14.207.99");
	var $debugResult = Array();
	var $userAgent = "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.2.1) Gecko/20021204";
	var $cacheDir = "";
	var $maxCacheAge = 86400; // = 24h (yes, in seconds)
	var $useCache = false;
	var $debug = false;

	//Private vars
	var $GOOGLE_MAGIC = 0xE6359A60;
	var $PageRank = -1;
	var $cacheExpired = false;


	function GetPR($url,$forceNoCache = false) {
		global $mosConfig_absolute_path;
		$total_exec_start = $this->microtimeFloat();
		$result=array("",-1);

		if (($url.""!="")&&($url.""!="http://")) {

			$this->debugRes("url", $url);

			$this->cacheDir = (strlen($this->cacheDir) > 0)? $this->cacheDir:$mosConfig_absolute_path."/cache/";
			$this->cacheDir .= (substr($this->cacheDir,-1) != "/")? "/":"";

			// check for protocol
			$url_ = "info:".((substr(strtolower($url),0,7)!="http://")? "http://".$url:$url);
			$host = $this->googleDomains[mt_rand(0,count($this->googleDomains)-1)];
			$target = "/search";
			$querystring = sprintf("client=navclient-auto&ch=6%u&features=Rank&q=",$this->GoogleCH($this->strord($url_)));
			$querystring .= urlencode($url_);
			$contents="";

			$this->debugRes("host", $host);
			$this->debugRes("query_string", $querystring);
			$this->debugRes("user_agent", $this->userAgent);

			$query_exec_start = $this->microtimeFloat();

			if ($forceNoCache == true) {
				$this->debugRes("force_no_cache", "true");
			} elseif ($contents = $this->readCacheResult($url)) {
				$this->debugRes("read_from_cache", "true");
			} else {
				$this->cacheExpired = true;
			}


			// let's get ranking
			if (strlen(trim($contents)) == 0)
			if (@function_exists("curl_init")) {

				// allways use curl if available for performance issues
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, "http://".$host.$target."?".$querystring);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
				curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
				curl_setopt($ch, CURLOPT_USERAGENT, $this->userAgent);
				if (!($contents = trim(@curl_exec($ch)))) {
					$this->debugRes("error","curl_exec failed");
				}
				curl_close ($ch);
				$this->debugRes("method", "curl");

			} else {
				$this->debugRes("error","curl not installed");
				// use fsockopen as secondary method, to submit user agent
				if ($socket  = @fsockopen($host, "80", $errno, $errstr, 30)) {

					$request  = "GET $target?$querystring HTTP/1.0\r\n";
					$request .= "Host: $host\r\n";
					$request .= "User-Agent: ".$this->userAgent."\r\n";
					$request .= "Accept-Language: en-us, en;q=0.50\r\n";
					$request .= "Accept-Charset: ISO-8859-1, utf-8;q=0.66, *;q=0.66\r\n";
					$request .= "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,video/x-mng,image/png,image/jpeg,image/gif;q=0.2,text/css,*/*;q=0.1\r\n";
					$request .= "Connection: close\r\n";
					$request .= "Cache-Control: max-age=0\r\n\r\n";

					stream_set_timeout ( $socket,10);
					fwrite( $socket, $request );
					$ret = '';
					while (!feof($socket)) {
						$ret .= fread($socket,4096);
					}
					fclose($socket);
					$contents = trim(substr($ret,strpos($ret,"\r\n\r\n") + 4));
					$this->debugRes("method", "fsockopen");
				} else {
					$this->debugRes("error","fsockopen failed");
					// this way could cause problems because the Browser Useragent is not set...
					if ($contents = trim(@file_get_contents("http://".$host.$target."?".$querystring))) {
						$this->debugRes("method", "file_get_contents");
					} else {
						$this->debugRes("error","file_get_contents failed");
					}
				}

			}

			if ($this->cacheExpired == true)
			$this->updateCacheResult($url,$contents);

			$this->debugRes("query_exec_time",$this->microtimeFloat() - $query_exec_start);

			$result[0]=$contents;
			// Rank_1:1:0 = 0
			// Rank_1:1:5 = 5
			// Rank_1:1:9 = 9
			// Rank_1:2:10 = 10 etc
			$p=explode(":",$contents);
			if (isset($p[2])) $result[1]=$p[2];
		}

		if($result[1] == -1) $result[1] = 0;
		$this->PageRank =(int)$result[1];
		$this->debugRes("total_exec_time", $this->microtimeFloat() - $total_exec_start);
		$this->debugRes("result", $result);
		return $this->PageRank;

	}


	function debugRes($what,$sowhat) {
		if($this->debug == true) {
			$debugbt = debug_backtrace();
			$what = trim($what);
			$sowhat = @trim($sowhat) . " (Line : ".$debugbt[0]["line"].")";
			if ($what == "error") {
				$this->debugResult[$what][] = $sowhat;
			} else {
				$this->debugResult[$what] = $sowhat;
			}
		}
	}

	function microtimeFloat() {
		list($usec, $sec) = explode(" ", microtime());
		return ((float)$usec + (float)$sec);
	}


	function readCacheResult($url) {
		if ($this->useCache != true) {
			return false;
		}

		if (!is_dir($this->cacheDir)) {
			$this->debugRes("error","please create {$this->cacheDir}");
			return false;
		}

		$urlp = parse_url($url);
		$host_ = explode(".",$urlp["host"]);
		$path_ = (strlen(isset($urlp["query"]))>0)? urlencode($urlp["path"].$urlp["query"]):"default";

		$cache_file = $this->cacheDir;

		for ($i = count($host_)-1;$i>=0;$i--) {
			$cache_file .= $host_[$i]."/";
		}

		$cache_file .= $path_;
		$this->debugRes("cache_file", $cache_file);
		if (file_exists($cache_file)) {
			$mtime = filemtime($cache_file);
			if (time() - $mtime > $this->maxCacheAge) {
				$this->debugRes("cache", "expired");
				$this->cacheExpired = true;
				return false;
			} else {
				$this->cacheExpired = false;
				$this->debugRes("cache_age", time() - $mtime);
				return file_get_contents($cache_file);
			}
		}
		$this->debugRes("error","cache file not exists (reading)");
		return false;
	}

	function updateCacheResult($url,$content) {
		if ($this->useCache != true) {
			return false;
		}

		if (!is_dir($this->cacheDir)) {
			$this->debugRes("error","please create {$this->cacheDir}");
			return false;
		}

		$urlp = parse_url($url);
		$host_ = explode(".",$urlp["host"]);
		$path_ = (strlen($urlp["query"])>0)? urlencode($urlp["path"].$urlp["query"]):"default";

		$cache_file = $this->cacheDir;
		for ($i = count($host_)-1;$i>=0;$i--) {
			$cache_file .= $host_[$i]."/";
		}

		$cache_file .= $path_;

		if (!file_exists($cache_file)) {
			$this->debugRes("error","cache file not exists (writing)");
			$cache_file_tmp = substr($cache_file,strlen($this->cacheDir));
			$cache_file_tmp = explode("/",$cache_file_tmp);
			$cache_dir_ = $this->cacheDir;
			for ($i = 0;$i<count($cache_file_tmp)-1;$i++) {
				$cache_dir_ .= $cache_file_tmp[$i]."/";
				if (!file_exists($cache_dir_)) {
					if (!@mkdir($cache_dir_,0777)) {
						$this->debugRes("error","unable to create cache dir: $cache_dir_");
						//break;
					}
				}
			}
			if (!@touch($cache_file)) $this->debugRes("error","unable to create cache file");
			if (!@chmod($cache_file,0777)) $this->debugRes("error","unable to chmod cache file");
		}

		if (is_writable($cache_file)) {
			if (!$handle = fopen($cache_file, 'w')) {
				$this->debugRes("error", "unable to open $cache_file");
				return false;
			}
			if (fwrite($handle, $content) === FALSE) {
				$this->debugRes("error", "unable to write to $cache_file");
				return false;
			}
			fclose($handle);
			$this->debugRes("cached", date("Y-m-d H:i:s"));
			return true;
		}
		$this->debugRes("error", "$cache_file is not writable");
		return false;

	}

	function zeroFill($a, $b) {
		$z = hexdec(80000000);
		if ($z & $a) {
			$a = ($a>>1);
			$a &= (~$z);
			$a |= 0x40000000;
			$a = ($a>>($b-1));
		} else {
			$a = ($a>>$b);
		}
		return $a;
	}

	function mix($a,$b,$c) {
		$a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,13));
		$b -= $c; $b -= $a; $b ^= ($a<<8);
		$c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,13));
		$a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,12));
		$b -= $c; $b -= $a; $b ^= ($a<<16);
		$c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,5));
		$a -= $b; $a -= $c; $a ^= ($this->zeroFill($c,3));
		$b -= $c; $b -= $a; $b ^= ($a<<10);
		$c -= $a; $c -= $b; $c ^= ($this->zeroFill($b,15));

		return array($a,$b,$c);
	}

	function GoogleCH($url, $length=null) {
		if(is_null($length)) {
			$length = sizeof($url);
		}
		$a = $b = 0x9E3779B9;
		$c = $this->GOOGLE_MAGIC;
		$k = 0;
		$len = $length;
		while($len >= 12) {
			$a += ($url[$k+0] +($url[$k+1]<<8) +($url[$k+2]<<16) +($url[$k+3]<<24));
			$b += ($url[$k+4] +($url[$k+5]<<8) +($url[$k+6]<<16) +($url[$k+7]<<24));
			$c += ($url[$k+8] +($url[$k+9]<<8) +($url[$k+10]<<16)+($url[$k+11]<<24));
			$mix = $this->mix($a,$b,$c);
			$a = $mix[0]; $b = $mix[1]; $c = $mix[2];
			$k += 12;
			$len -= 12;
		}

		$c += $length;
		switch($len) /* all the case statements fall through */
		{
			case 11: $c+=($url[$k+10]<<24);
			case 10: $c+=($url[$k+9]<<16);
			case 9 : $c+=($url[$k+8]<<8);
			/* the first byte of c is reserved for the length */
			case 8 : $b+=($url[$k+7]<<24);
			case 7 : $b+=($url[$k+6]<<16);
			case 6 : $b+=($url[$k+5]<<8);
			case 5 : $b+=($url[$k+4]);
			case 4 : $a+=($url[$k+3]<<24);
			case 3 : $a+=($url[$k+2]<<16);
			case 2 : $a+=($url[$k+1]<<8);
			case 1 : $a+=($url[$k+0]);
			/* case 0: nothing left to add */
		}
		$mix = $this->mix($a,$b,$c);
		/*-------------------------------------------- report the result */
		return $mix[2];
	}

	//converts a string into an array of integers containing the numeric value of the char
	function strord($string) {
		for($i=0;$i<strlen($string);$i++) {
			$result[$i] = ord($string{$i});
		}
		return $result;
	}

}
?>